//
// $HeadURL: $
//
// $Author: $
// $Date:  $
// $Revision: $
//
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
// 02111-1307, USA.
//
// http://www.gnu.org/copyleft/gpl.html
//
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Management;
using System.Windows.Forms;

namespace EnvVariables
{
	/// <summary>
	/// Summary description for EnvVariables.
	/// </summary>
	public class EnvVariables : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListBox _lbVariables;
		private System.Windows.Forms.TextBox _txtValue;
		private System.Windows.Forms.Button _btnApply;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private bool _valueChanged;
		private System.Windows.Forms.Button _btnAdd;
		private System.Windows.Forms.Button _btnDelete;
		private String _varName;
		private ManagementClass _envClass;
		private bool _update;

		public EnvVariables()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			_update = true;
			FormatForWinXP(this);
			_envClass = new ManagementClass("Win32_Environment");
			ReloadVariables();
			_update = false;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		/// <summary>
		/// Search the control for button type control and set the FlatStyle
		/// of these buttons to System. This method searches Recursively into
		/// control within control. 
		/// </summary>
		/// <param name="control">Control to search children of</param>
		private void FormatForWinXP(Control control)
		{
			foreach( Control ctrlChild in control.Controls )
			{
				// Set FlatStyle.System if it is a button type control
				if(ctrlChild.GetType().BaseType == typeof(ButtonBase))
				{
					((ButtonBase)ctrlChild).FlatStyle = FlatStyle.System; 
				}

				// Dive into the child controls if there are any
				if(ctrlChild.Controls.Count > 0)
				{
					FormatForWinXP(ctrlChild);
				}
			}
		}

		private void ReloadVariables()
		{
			_lbVariables.Items.Clear();
			ManagementObjectSearcher searcher = new ManagementObjectSearcher("Select * from Win32_Environment where UserName = '<SYSTEM>'");
            
			foreach (ManagementObject obj in searcher.Get()) 
			{
				_lbVariables.Items.Add(obj["Name"]);
			}


			_lbVariables.SelectedIndex = 0;
			_lbVariables.Sorted = true;
			_varName = _lbVariables.SelectedItem.ToString();
			_valueChanged = false;
			LoadSelectedVariable();
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(EnvVariables));
			this._lbVariables = new System.Windows.Forms.ListBox();
			this._txtValue = new System.Windows.Forms.TextBox();
			this._btnApply = new System.Windows.Forms.Button();
			this._btnAdd = new System.Windows.Forms.Button();
			this._btnDelete = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// _lbVariables
			// 
			this._lbVariables.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this._lbVariables.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this._lbVariables.ItemHeight = 14;
			this._lbVariables.Location = new System.Drawing.Point(8, 8);
			this._lbVariables.Name = "_lbVariables";
			this._lbVariables.Size = new System.Drawing.Size(428, 102);
			this._lbVariables.TabIndex = 2;
			this._lbVariables.SelectedIndexChanged += new System.EventHandler(this.VariablesSelectedIndexChanged);
			// 
			// _txtValue
			// 
			this._txtValue.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this._txtValue.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this._txtValue.Location = new System.Drawing.Point(8, 168);
			this._txtValue.MaxLength = 131072;
			this._txtValue.Multiline = true;
			this._txtValue.Name = "_txtValue";
			this._txtValue.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this._txtValue.Size = new System.Drawing.Size(428, 210);
			this._txtValue.TabIndex = 3;
			this._txtValue.Text = "";
			this._txtValue.TextChanged += new System.EventHandler(this.VariableValue_TextChanged);
			// 
			// _btnApply
			// 
			this._btnApply.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this._btnApply.Enabled = false;
			this._btnApply.Location = new System.Drawing.Point(332, 385);
			this._btnApply.Name = "_btnApply";
			this._btnApply.Size = new System.Drawing.Size(88, 23);
			this._btnApply.TabIndex = 4;
			this._btnApply.Text = "Apply";
			this._btnApply.Click += new System.EventHandler(this.BtnApply_Click);
			// 
			// _btnAdd
			// 
			this._btnAdd.Anchor = System.Windows.Forms.AnchorStyles.Top;
			this._btnAdd.Location = new System.Drawing.Point(142, 120);
			this._btnAdd.Name = "_btnAdd";
			this._btnAdd.TabIndex = 5;
			this._btnAdd.Text = "Add";
			this._btnAdd.Click += new System.EventHandler(this.BtnAdd_Click);
			// 
			// _btnDelete
			// 
			this._btnDelete.Anchor = System.Windows.Forms.AnchorStyles.Top;
			this._btnDelete.Location = new System.Drawing.Point(230, 120);
			this._btnDelete.Name = "_btnDelete";
			this._btnDelete.TabIndex = 6;
			this._btnDelete.Text = "Delete";
			this._btnDelete.Click += new System.EventHandler(this.BtnDelete_Click);
			// 
			// EnvVariables
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(442, 420);
			this.Controls.Add(this._btnDelete);
			this.Controls.Add(this._btnAdd);
			this.Controls.Add(this._btnApply);
			this.Controls.Add(this._txtValue);
			this.Controls.Add(this._lbVariables);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MinimumSize = new System.Drawing.Size(450, 450);
			this.Name = "EnvVariables";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "EnvVariables 0.5.1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Main
		/// </summary>
		[STAThread]
		public static void Main(string[] args) 
		{
			Application.Run(new EnvVariables());
		}

		private void VariablesSelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (!_update)
			{
				if (_valueChanged)
				{
					if (DialogResult.OK == MessageBox.Show("Do you want to save you changes", "Save changes?", 
						MessageBoxButtons.YesNo, MessageBoxIcon.Question))
					{
						Save();
					}
				}

				LoadSelectedVariable();
			}
		}

		private void LoadSelectedVariable()
		{
			if (_lbVariables.SelectedIndex > -1)
			{
				_varName = _lbVariables.SelectedItem.ToString();
				string envPath = "Win32_Environment.Name='" + _varName + "'" + ",UserName='<SYSTEM>'";

				ManagementObject envObject = new ManagementObject(envPath);

				_txtValue.Text = envObject["VariableValue"].ToString();
				_valueChanged = false;
				_btnApply.Enabled = false;
			}
		}

		private void VariableValue_TextChanged(object sender, System.EventArgs e)
		{
			_valueChanged = true;
			_btnApply.Enabled = true;
		}

		private void BtnApply_Click(object sender, System.EventArgs e)
		{
			Save();
		}

		private void Save()
		{
			Cursor = Cursors.WaitCursor;
			_update = true;

			try
			{
				string envPath = "Win32_Environment.Name='" + _varName + "'" + ",UserName='<SYSTEM>'";

				ManagementObject envObj = new ManagementObject(envPath);
				envObj["VariableValue"] = _txtValue.Text.Trim();
				_txtValue.Text = _txtValue.Text.Trim();

				_btnApply.Enabled = false;
				_valueChanged = false;

				envObj.Put();
			}
			catch (Exception e)
			{
				MessageBox.Show(e.Message + "\n" + e.StackTrace, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
            
			Cursor = Cursors.Default;
			_update = false;
		}

		private void BtnAdd_Click(object sender, System.EventArgs e)
		{
			_update = true;

			try
			{
				NewEnvVariable newEnvDialog = new NewEnvVariable();
				DialogResult result = newEnvDialog.ShowDialog(this);
				if (result.Equals(DialogResult.OK))
				{
					Cursor = Cursors.WaitCursor;
					ManagementObjectSearcher searcher = new ManagementObjectSearcher("Select * from Win32_Environment where Name = '"
																					 + newEnvDialog.NewVariableName + "'");
	            
					bool found = false;
					foreach (ManagementObject obj in searcher.Get()) 
					{
						found = true;
						break;
					}
					
					if (found)
					{
						MessageBox.Show(this, "An environment variable with the name '"
							+ newEnvDialog.NewVariableName + "' already exists.", "Variable already exists.", 
							MessageBoxButtons.OK, MessageBoxIcon.Error);
					}
					else
					{
						ManagementObject envObj = _envClass.CreateInstance();
						envObj["UserName"] = "<SYSTEM>";
						envObj["Name"] = newEnvDialog.NewVariableName;
						envObj["VariableValue"] = newEnvDialog.NewVariableValue;
						envObj.Put();

						ReloadVariables();
					}
				}
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message + "\n" + ex.StackTrace, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
			}

			Cursor = Cursors.Default;
			_update = false;
		}

		private void BtnDelete_Click(object sender, System.EventArgs e)
		{
			Cursor = Cursors.WaitCursor;
			_update = true;

			DialogResult result = MessageBox.Show(this, "Do you really want to delete the environment variable '" + _varName + "'?\n"
				+ "This operation cannot be reverted.", "Delete the environment variable '" + _varName + "'?", 
				MessageBoxButtons.OKCancel, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2);
			if (result.Equals(DialogResult.OK))
			{
				string envPath = "Win32_Environment.Name='" + _varName + "'" + ",UserName='<SYSTEM>'";

				ManagementObject envObj = new ManagementObject(envPath);
				envObj.Delete();
			}

			ReloadVariables();

			Cursor = Cursors.Default;
			_update = false;
		}
	}
}
