//
// $HeadURL: $
//
// $Author: $
// $Date:  $
// $Revision: $
//
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
// 02111-1307, USA.
//
// http://www.gnu.org/copyleft/gpl.html
//
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace EnvVariables
{
	/// <summary>
	/// Summary description for NewEnvVariable.
	/// </summary>
	public class NewEnvVariable : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label _lblNewEnvVariable;
		private System.Windows.Forms.Button _btnOk;
		private System.Windows.Forms.Button _btnCancel;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox _txtValue;
		private System.Windows.Forms.TextBox _txtName;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public NewEnvVariable()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			FormatForWinXP(this);
		}

		/// <summary>
		/// Search the control for button type control and set the FlatStyle
		/// of these buttons to System. This method searches Recursively into
		/// control within control. 
		/// </summary>
		/// <param name="control">Control to search children of</param>
		private void FormatForWinXP(Control control)
		{
			foreach( Control ctrlChild in control.Controls )
			{
				// Set FlatStyle.System if it is a button type control
				if(ctrlChild.GetType().BaseType == typeof(ButtonBase))
				{
					((ButtonBase)ctrlChild).FlatStyle = FlatStyle.System; 
				}

				// Dive into the child controls if there are any
				if(ctrlChild.Controls.Count > 0)
				{
					FormatForWinXP(ctrlChild);
				}
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this._lblNewEnvVariable = new System.Windows.Forms.Label();
			this._txtName = new System.Windows.Forms.TextBox();
			this._btnOk = new System.Windows.Forms.Button();
			this._btnCancel = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this._txtValue = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// _lblNewEnvVariable
			// 
			this._lblNewEnvVariable.Location = new System.Drawing.Point(8, 8);
			this._lblNewEnvVariable.Name = "_lblNewEnvVariable";
			this._lblNewEnvVariable.Size = new System.Drawing.Size(88, 23);
			this._lblNewEnvVariable.TabIndex = 0;
			this._lblNewEnvVariable.Text = "Variable Name:";
			// 
			// _txtName
			// 
			this._txtName.Location = new System.Drawing.Point(112, 8);
			this._txtName.Name = "_txtName";
			this._txtName.Size = new System.Drawing.Size(272, 20);
			this._txtName.TabIndex = 1;
			this._txtName.Text = "";
			// 
			// _btnOk
			// 
			this._btnOk.Location = new System.Drawing.Point(224, 200);
			this._btnOk.Name = "_btnOk";
			this._btnOk.TabIndex = 3;
			this._btnOk.Text = "OK";
			this._btnOk.Click += new System.EventHandler(this.BtnOK_Click);
			// 
			// _btnCancel
			// 
			this._btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this._btnCancel.Location = new System.Drawing.Point(304, 200);
			this._btnCancel.Name = "_btnCancel";
			this._btnCancel.TabIndex = 4;
			this._btnCancel.Text = "Cancel";
			this._btnCancel.Click += new System.EventHandler(this.BtnCancel_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 40);
			this.label1.Name = "label1";
			this.label1.TabIndex = 0;
			this.label1.Text = "Variable Value:";
			// 
			// _txtValue
			// 
			this._txtValue.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this._txtValue.Location = new System.Drawing.Point(112, 40);
			this._txtValue.MaxLength = 131072;
			this._txtValue.Multiline = true;
			this._txtValue.Name = "_txtValue";
			this._txtValue.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this._txtValue.Size = new System.Drawing.Size(272, 144);
			this._txtValue.TabIndex = 2;
			this._txtValue.Text = "";
			// 
			// NewEnvVariable
			// 
			this.AcceptButton = this._btnOk;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this._btnCancel;
			this.ClientSize = new System.Drawing.Size(394, 236);
			this.Controls.Add(this._txtValue);
			this.Controls.Add(this.label1);
			this.Controls.Add(this._btnCancel);
			this.Controls.Add(this._btnOk);
			this.Controls.Add(this._txtName);
			this.Controls.Add(this._lblNewEnvVariable);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "NewEnvVariable";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "New environment variable";
			this.TopMost = true;
			this.ResumeLayout(false);

		}
		#endregion

		private void BtnOK_Click(object sender, System.EventArgs e)
		{
			if (_txtName.Text.Trim().Length > 0 && _txtValue.Text.Trim().Length > 0)
			{
				DialogResult = DialogResult.OK;
				Close();
			}
			else
			{
				MessageBox.Show(this, "Please enter a name and a value for the new environment variable.", "Could not add new variable", 
					MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
			}
		}

		private void BtnCancel_Click(object sender, System.EventArgs e)
		{
			DialogResult = DialogResult.Cancel;
			Close();
		}

		public string NewVariableName
		{
			get
			{
				return _txtName.Text.Trim();
			}
		}

		public string NewVariableValue
		{
			get
			{
				return _txtValue.Text.Trim();
			}
		}

	}
}
